﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Desenare
{
    public partial class Form1 : Form
    {
        Graphics G;//panoul de desenare
        Pen P;//creionul
        SolidBrush SB;//pensula
        int xv, yv;//coordonatele anterioare pt linie si dreptunghi
        List<Point> L;//lista de puncte pentru poligon

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            G = pictureBox1.CreateGraphics();//asociez G cu pictureboxul
            P = new Pen(Color.Black);//creez un creion cu negru
            SB = new SolidBrush(Color.Black);//creez o pensula cu negru
            L = new List<Point>();//creez lista de puncte
            groupBox2.Visible = false;
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            //calcularea coordonatelor clickului in picturebox!!!!
            int x = MousePosition.X;//coordonatele de pe ecran
            int y = MousePosition.Y;
            x = x - this.Left;//scad coordonatele unde incepe forma
            y = y - this.Top;
            x = x - pictureBox1.Left;////scad coordonatele pictureboxului
            y = y - pictureBox1.Top;
            x = x - 8;//scad grosimea bordurii formei
            y = y - 31;//scad grosimea barei de titul

            int r=(int)numericUpDown1.Value;//diametrul cercului sau latura patratului

            if(radioButton1.Checked==true)//punct
                G.DrawEllipse(P,x,y,1,1);
            if (radioButton3.Checked == true)//cerc
                G.DrawEllipse(P, x-r, y-r, 2*r, 2*r);
            if (radioButton4.Checked == true)//disc
                G.FillEllipse(SB, x - r, y - r, 2 * r, 2 * r);
            if (radioButton5.Checked == true)//patrat
                G.DrawRectangle(P, x-r/2, y-r/2, r, r);
            if (radioButton6.Checked == true)//patrat plin
                G.FillRectangle(SB, x - r / 2, y - r / 2, r, r);
            if (radioButton2.Checked == true)//segment
                if (xv == 0)//primul click
                { xv = x; yv = y; }
                else //al doilea click
                {
                    G.DrawLine(P, xv, yv, x, y);
                    xv = yv = 0;
                }
            if(radioButton7.Checked==true)//dreptunghi
                if (xv == 0)
                { xv = x; yv = y; }
                else
                {
                    int lx = Math.Abs(x - xv);//laturile
                    int ly = Math.Abs(y - yv);
                    xv = Math.Min(x, xv);//coltul stanga sus
                    yv = Math.Min(y, yv);
                    G.DrawRectangle(P, xv, yv, lx, ly);
                    xv = yv = 0;
                }
            if (radioButton8.Checked == true)//dreptunghi plin
                if (xv == 0)
                { xv = x; yv = y; }
                else
                {
                    int lx = Math.Abs(x - xv);//laturile
                    int ly = Math.Abs(y - yv);
                    xv = Math.Min(x, xv);//coltul stanga sus
                    yv = Math.Min(y, yv);
                    G.FillRectangle(SB, xv, yv, lx, ly);
                    xv = yv = 0;
                }
            if (radioButton9.Checked == true)//poligon
                L.Add(new Point(x,y));//adaug punctul in lista
            if (radioButton10.Checked == true)//poligon plin
                L.Add(new Point(x, y));//adaug punctul in lista
        }

        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            if(radioButton9.Checked==true)//poligon
            {
                Point[] V=new Point[L.Count];//creez vectorul de puncte
                for(int i=0;i<L.Count;i++)//copiez punctele
                    V[i]=L[i];
                G.DrawPolygon(P,V);
                L.Clear();//golesc lista
            }
            if (radioButton10.Checked == true)//poligon plin
            {
                Point[] V = new Point[L.Count];//creez vectorul de puncte
                for (int i = 0; i < L.Count; i++)//copiez punctele
                    V[i] = L[i];
                G.FillPolygon(SB, V);
                L.Clear();//golesc lista
            }
                    
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                P = new Pen(colorDialog1.Color);//schimb culoarea creionului
                SB.Color = colorDialog1.Color;//schimb culoarea pensulei 
                pictureBox2.BackColor=colorDialog1.Color;
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
                groupBox2.Visible = false;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked == true)
            {
                groupBox2.Visible = true;
                groupBox2.Text = "Raza cercului";
            }
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked == true)
            {
                groupBox2.Visible = true;
                groupBox2.Text = "Raza discului";
            }
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked == true)
            {
                groupBox2.Visible = true;
                groupBox2.Text = "Latura patratului";
            }
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6.Checked == true)
            {
                groupBox2.Visible = true;
                groupBox2.Text = "Latura patratului";
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked == true)
                groupBox2.Visible = false;
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton7.Checked == true)
                groupBox2.Visible = false;
        }

        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton8.Checked == true)
                groupBox2.Visible = false;
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton10.Checked == true)
            {
                groupBox2.Visible = false;
                L.Clear();
            }
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton9.Checked == true)
            {
                groupBox2.Visible = false;
                L.Clear();
            }
        }
    }
}
